import { APIGatewayProxyEvent, APIGatewayProxyResult } from 'aws-lambda';
import type { Environment } from '../config';
import { Logger } from '../logging';
export interface AllocateRequest {
    readonly pool: string;
    readonly requester: string;
    readonly durationSeconds?: number;
}
export interface Credentials {
    readonly accessKeyId: string;
    readonly secretAccessKey: string;
    readonly sessionToken: string;
}
export interface AllocateResponse {
    readonly id: string;
    readonly environment: Environment;
    readonly credentials: Credentials;
    readonly durationSeconds: number;
}
export declare function handler(event: APIGatewayProxyEvent): Promise<APIGatewayProxyResult>;
export declare function doHandler(allocationId: string, request: AllocateRequest, log: Logger): Promise<APIGatewayProxyResult>;
